import 'package:flutter/material.dart';
import 'package:flutter_map_polywidget/flutter_map_polywidget.dart';
import 'package:flutter_map_polywidget/src/editor/layer/state.dart';

class PolyWidgetEditorLayerProvider extends StatefulWidget {
  final Widget Function(BuildContext context, PolyWidgetData? data) builder;

  const PolyWidgetEditorLayerProvider({
    required this.builder,
    super.key,
  });

  @override
  State<PolyWidgetEditorLayerProvider> createState() =>
      _PolyWidgetEditorLayerProviderState();
}

class _PolyWidgetEditorLayerProviderState
    extends State<PolyWidgetEditorLayerProvider> {
  PolyWidgetData? data;

  @override
  Widget build(BuildContext context) {
    return PolyWidgetEditorLayerState(
      onEdit: (data) {
        setState(() {
          if (this.data == null) {
            this.data = data;
          } else {
            this.data = null;
          }
        });
      },
      child: widget.builder.call(context, data),
    );
  }
}